#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "m_data.h"
#include "m_sr.h"

/* Save, restore routines */

void SaveMusStatus(struct MusData *Buf)
{
	int p = MusData.Paused;
	SetPause(1);
    FreeUncompressedData();
    memcpy(Buf, &MusData, sizeof(*Buf));
    /* FIXME: Save music device status */
    SetPause(p);
}

void RestoreMusStatus(const struct MusData *Buf)
{
	SetPause(1);
    memcpy(&MusData, Buf, sizeof(*Buf));
    if(MusData.driver)MusData.driver->reset();
    UncompressChannels();
    /* Paused flag was saved as 1 */
    SetPause(0);
}

void FreeUncompressedData(void)
{
	unsigned a;
	for(a=0; a<MAXCHN; ++a)
	{
		if(MusData.PlayData.ch[a].patndata)
			free(MusData.PlayData.ch[a].patndata);
	}
}

void UncompressChannels(void)
{
	unsigned a;
	
	const struct InternalChanData *chans = MusData.SongData.Chans[MusData.PlayData.posi.Pat];
	
	printf("Pattern %u:\n", MusData.PlayData.posi.Pat);
	
	for(a=0; a<MusData.SongData.Hdr->ChanCount; ++a)
	{
		const BYTE *src = (const BYTE *)chans + sizeof(*chans);
		BYTE *dest = (BYTE *)calloc(chans->OriginalByteSize, 1); /* We want zero */
		unsigned srcbitpos=0, destbitpos=0;
		
		const BYTE bbb = ReadBits(src, srcbitpos,   4);
		const BYTE ooo = ReadBits(src, srcbitpos+4, 4);
		const BYTE ppp=5+ReadBits(src, srcbitpos+8, 1);
		const BYTE limit = 1 + bbb + ooo;
		
		srcbitpos += 4+4+1;
		
		MusData.PlayData.ch[a].patndata = dest;
		
		printf("  a=%u: bbb=%u, ooo=%u, ppp=%u\n", a, bbb, ooo, ppp);
		
		/* DWORD ReadBits(const BYTE *data, unsigned bitpos, unsigned bitcount)       */
		/* void WriteBits(BYTE *dest, unsigned bitpos, unsigned bitcount, DWORD data) */

		for(; srcbitpos < chans->BitCount; )
		{
			BYTE k = ReadBits(src, srcbitpos++, 1);
			if(k)
			{
				WORD bb = ReadBits(src, srcbitpos,       bbb);
				WORD oo = ReadBits(src, srcbitpos + bbb, ooo);
				srcbitpos += bbb + ooo;
				
				printf("   Got bb=%u, oo=%u (destbitpos=%u).\n", bb,oo, destbitpos);
				
				bb = bb+limit+1;
				oo = destbitpos-oo-1;
				
				CopyBits(dest, destbitpos, dest, oo, bb);
				destbitpos += bb;
			}
			else
			{
				WORD pp = ReadBits(src, srcbitpos, ppp);
				srcbitpos += ppp;
				
				printf("   Got ppp=%u at destbitpos=%u\n", pp, destbitpos);
				
				CopyBits(dest, destbitpos, src, srcbitpos, pp);
				destbitpos += pp;
				srcbitpos  += pp;
			}
		}
		
		chans = (const struct InternalChanData *)((const BYTE *)chans + ((chans->BitCount+7) >> 3) + sizeof(*chans));
	}
}
